;;; breakpoint.scm                               V-2018
;;; vvvvv bkpt vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
; bkpt - benoetigt ausgabe und warte-taste
; kann auch ohne Parameter aufgerufen werden und bietet die Moeglichkeit,
; eine Funktion zu unterbrechen und ggf. Ausdruecke
; auszuwerten und anzuzeigen.
(define
  (bkpt . Parameter)
  (apply ausgabe Parameter)
  (warte-taste))

;;; vvvvv break-value vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
; break-value  -  benoetigt ausgabe und warte-taste
; muss als ersten Parameter den zu uebergebenen Wert bekommen und
; gibt diesen Wert zurueck.
; kann auch au?erdem noch Parameter Ausdruecke auswerten und anzeigen.
(define
  (break-value value . Parameter)
  (if
   (not (null? Parameter))
   (apply ausgabe (cons "Parameter: " Parameter)))
  (ausgabe "Wert: " value)
  (warte-taste)
  value)


;;; vvvvv warte-taste vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
; warte-taste - keine Parameter moeglich
; wartet auf einen Tastendruck mit anschliessendem ENTER
(define
  (warte-taste)
  (ausgabe "weiter mit          <Leertaste>   und   <ENTER>")
  (ausgabe "Abbruch mit F[e]hler   <e>        und   <ENTER>")
  (let
      ((ch (peek-char)))
    (read-line)
    (cond
      ((equal? ch #\newline)(warte-taste))
      ((char=? ch #\space)(void))
      ((or (char=? ch #\E) (char=? ch #\e))
       (error "Abbruch mit Fehlermeldung"))
      (else
       (warte-taste)))))

;;; vvvvv ausgabe vvv vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
; ausgabe - beliebige Parameter moeglich
(define
  (ausgabe . daten)
  (cond
    ((null? daten) (newline))
    (else
     (display (car daten))
     (display #\space)
     (apply ausgabe (cdr daten)))))

;;; vvvvv ausgabe-value vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
; entsprechend break-value mit ausgabe
; muss als ersten Parameter den zu uebergebenen Wert bekommen und
; gibt diesen Wert zurueck.
; kann auch ausserdem noch Parameter Ausdruecke auswerten und anzeigen.
(define
  (ausgabe-value value . Parameter)
  (if
   (not (null? Parameter))
   (apply ausgabe (cons "Parameter: " Parameter)))
  (ausgabe "Wert: " value)
  value)
;;; ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^