;;; wege_Erarbeitung.scm
;;; stellt die Funktionen fuer die Verwaltung der Wege bereit

(load "gallenbacher-graph-kanten.scm")
; Verwendet wird davon die Kantenliste *kanten*
; und die Zugriffsfunktion (nachfolge-kanten <aktuelle-stadt> <kanten>)

; Wege sind Listen aus der Laenge und den besuchten Knoten (rueckwaerts)
; Muster: (60 X B I)

;;; ===== alle-nachfolge-wege =====
; gibt zum aktuellen Weg alle Wege zurueck, die sich aus den
; Nachfolgekanten ergeben.
(define
  (alle-nachfolge-wege weg kanten)
  (define
    (alle-intern nachfolgekanten neue-wege)
    (cond ; Rekursion ueber Liste, daher:
      ((null? nachfolgekanten) neue-wege) ; fertig 
      ((equal? (second (first nachfolgekanten)) (third weg)) ; nicht zurueck!
       (alle-intern (rest nachfolgekanten) neue-wege)) ; weiter ohne die Kante
      (else
       (alle-intern
        (rest nachfolgekanten)
        (cons
         (neuer-weg weg (first nachfolgekanten))
         neue-wege)))
      ))
  (alle-intern
   (nachfolge-kanten
    (second weg) ; der aktuelle Knoten steht nach der Laenge im weg
    kanten)
   '()))


;;; ===== Hilfsfunktion neuer-weg =====
; Gibt zu einem Weg und zu einer Kante den verlaengerten Weg zurueck.
(define
  (neuer-weg weg kante)
  (cons
   (+ (first weg) (third kante))  ; neue Weglaenge
   (cons (second kante) (rest weg)) ; Zielort der Kante vorn einbauen
   )
  )
;Tests:
(neuer-weg '(60 X B I) '(X N 29))
(neuer-weg '(60 X B I) '(X B 26))
; -> '(89 N X B I)

;;; ===== alle-nachfolge-wege =====
; Tests:
(alle-nachfolge-wege '(22 N A) *kanten*)
; -> '((52 Z N A) (51 X N A) (42 D N A))
